import {
  DetailInformation,
  devicedetails_default
} from "./chunk-TZUFPBGW.js";

// src/auditlogs/eventdetails/filetransfer.js
import React, { useEffect } from "react";
import { useDispatch, useSelector } from "react-redux";
import { useTheme } from "@mui/material/styles";
import Loader from "@northern.tech/common-ui/loader";
import { getAuditlogDevice, getIdAttribute, getUserCapabilities } from "@northern.tech/store/selectors";
import { getDeviceById } from "@northern.tech/store/thunks";
import { jsx, jsxs } from "react/jsx-runtime";
var FileTransfer = ({ item, onClose }) => {
  const dispatch = useDispatch();
  const {
    actor,
    meta: { path = [] },
    object = {}
  } = item;
  const device = useSelector(getAuditlogDevice);
  const { canReadDevices } = useSelector(getUserCapabilities);
  const idAttribute = useSelector(getIdAttribute);
  const theme = useTheme();
  useEffect(() => {
    if (canReadDevices) {
      dispatch(getDeviceById(object.id));
    }
  }, [canReadDevices, dispatch, object.id]);
  if (canReadDevices && !device) {
    return /* @__PURE__ */ jsx(Loader, { show: true });
  }
  const sessionMeta = {
    Path: path.join(","),
    User: actor.email
  };
  return /* @__PURE__ */ jsxs("div", { className: "flexbox column", style: { margin: theme.spacing(3), minWidth: "min-content" }, children: [
    canReadDevices && /* @__PURE__ */ jsx(devicedetails_default, { device, idAttribute, onClose }),
    /* @__PURE__ */ jsx(DetailInformation, { title: "file transfer", details: sessionMeta })
  ] });
};
var filetransfer_default = FileTransfer;

export {
  FileTransfer,
  filetransfer_default
};
//# sourceMappingURL=chunk-TISEN7C7.js.map